/*
iso1.cc
*/  
#include <check.cch>
#define W1 1
#define W2 2
#define W4 4

#define V1 1
#define V2 2
#define V4 4
#define V8 8
#define V16 16
#define V32 32
#define V64 64

#define SEQ_PT(x) \
if (option('V') & V1 )warn(1101,"sequence point (%s)",x);\
if (assign_count>2)	\
	{\
	if (option('W') & W1 ) warn(1001,"%d assignments between sequence points; check G1.7-8, G2.18",assign_count);\
	}\
assign_count=0

char calledOnes[1200];


int paren_depth;   
int depth, equals_just_seen,	assign_count, style;


int if_seen;
int for_seen;
int while_seen;
int switch_seen;

int call_count0;
int call_count1;
int call_count2;
int call_count3;
int call_count4;
int call_count5;
int call_count6;
int call_count7;
int called_value;

if (dcl_initializer)
	{
	SEQ_PT("end initializer");
	}
if (keyword("if"))
	{
	if_seen=1;
	paren_depth=0;
	}
if (keyword("for"))
	{
	for_seen=3;
	paren_depth=0;
	}
if (keyword("while"))
	{
	while_seen=1;
	paren_depth=0;
	}
if (keyword("switch"))
	{
	switch_seen=1;
	paren_depth=0;
	}
if (prj_begin)
	{
	warn(1000,"iso1.cc version 1.0 13-oct-1997");
	call_count0=0;
	depth=0;
	equals_just_seen=0;
	assign_count=0;
	for_seen=0;
	}

if (idn_variable)
	{
	if (lin_within_function)
		{
		if (equals_just_seen)
			{
			if (!idn_local)
				{
				if (option('V') & V2)warn(1102,"fcn %s writes global %s at depth %d",fcn_name(), idn_name(), depth);
				}
			else
				{
				if (option('V') & V4)warn(1104,"fcn %s writes local %s at depth %d",fcn_name(), idn_name(), depth);
				}
			equals_just_seen=0;
			}
		else
			{
			if (!idn_local)
				{
				if (option('V') & V8)warn(1108,"fcn %s reads global %s at depth %d",fcn_name(), idn_name(), depth);
				}
			else
				{
				if (option('V') & V16)warn(1116,"fcn %s reads local %s at depth %d",fcn_name(), idn_name(), depth);
				}
			}
		}
	}

if (lex_token)
	{
	if (lin_within_function)
		{
		if (strcmp(token(),"=")==0)
			{
			equals_just_seen=1;
			}
		}
	}


if (stm_end)
	{
	//SEQ_PT("end full expression");
	if (call_count0>1)
		{
if (option('W') & W4 ) warn(1004,"Warning: %d fcn calls in one expression; check G1.8",call_count0);
		}

	call_count0=0;

	switch(stm_kind)
		{
			case(IF): if (option('V') & V1 )warn(1101,"end of IF statement"); break;
			case(ELSE): if (option('V') & V1 )warn(1101,"end of ELSE statement"); break;
			case(WHILE): if (option('V') & V1 )warn(1101,"end of WHILE statement"); break;
			case(DO): if (option('V') & V1 )warn(1101,"end of DO statement"); break;
			case(FOR): if (option('V') & V1 )warn(1101,"end of FOR statement"); break;
			case(SWITCH): if (option('V') & V1 )warn(1101,"end of SWITCH statement"); break;
			case(FCN_BODY): if (option('V') & V1 )warn(1101,"end of FCN_BODY statement"); break;
			case(COMPOUND): if (option('V') & V1 )warn(1101,"end of COMPOUND statement"); break;
			case(EXPRESSION): 
				{
				SEQ_PT("expression");
				if (option('V') & V1 )warn(1101,"end of EXPRESSION statement"); break;
				}
			case(BREAK): if (option('V') & V1 )warn(1101,"end of BREAK statement"); break;
			case(CONTINUE): if (option('V') & V1 )warn(1101,"end of CONTINUE statement"); break;
			case(RETURN): 
				{
				SEQ_PT("return");
				if (option('V') & V1 )warn(1101,"end of RETURN statement"); break;
				}
			case(GOTO): if (option('V') & V1 )warn(1101,"end of GOTO statement"); break;
			case(DECLARE): if (option('V') & V1 )warn(1101,"end of DECLARATION statement"); break;
			case(EMPTY): if (option('V') & V1 )warn(1101,"end of EMPTY statement"); break;
			default: if (option('V') & V1 )warn(1101,"end of ? statement"); break;
		}
	//assign_count=0;
	}


// 9300
if (op_low)
	{
	if (
			(op_add_assign)
				||
			(op_and_assign)
				||
			(op_assign)
				||
			(op_div_assign)
				||
			(op_left_assign)
				||
			(op_mul_assign)
				||
			(op_or_assign)
				||
			(op_rem_assign)
				||
			(op_right_assign)
				||
			(op_sub_assign)
				||
			(op_xor_assign)
									)
		{
		assign_count++;
		}
	else if (op_cond)
		{
		SEQ_PT("?");
		}
   else
      {
	   //if (style==VERBOSE) warn(9300,"other low precedence op");
      }
	}
// 9200
if (op_medium)
	{
	if (op_log_and) 
		{
		SEQ_PT("&&");
		}
	else if (op_log_or) 
		{
		SEQ_PT("||");
		}
	else if (op_add)
		{
		;//if (style==VERBOSE) warn(9201,"op +");
		}
	else
		{
		;//if (style==VERBOSE) warn(9200,"other medium precedence op");
		}
	}
// 9100
if (op_high)
	{
	if (op_call)
   	{
if (option('V')&V32) warn(1132,"fcn %s calls fcn %s at depth %d",fcn_name(),op_function(),depth);
		if (depth>=0)
			{
			switch(depth)
				{
				case(0):	call_count0++;	break;
				case(1):	call_count1++;	break;
				case(2):	call_count2++;	break;
				case(3):	call_count3++;	break;
				case(4):	call_count4++;	break;
				case(5):	call_count5++;	break;
				case(6):	call_count6++;	break;
				case(7):	call_count7++;	break;
				default:	warn(9101,"depth too great at %d - inform PSD",depth);
				}
			}   	
		}
	else
		{
		;//if (style==VERBOSE) warn(9100,"other high precedence op");
		}
	}
// 9400
if (op_punct)
	{
	if (op_comma)
		{
		SEQ_PT(",");
		}
	else if (op_open_paren)
		{
		paren_depth++;
/*
		if (for_seen)
			{
			warn(1010,"sequence point(start for)");
			for_seen=3;
			}
		else if (while_seen)
			{
			warn(1010,"sequence point(start while)");
			}
		if (switch_seen)
			{
			warn(1010,"sequence point(start switch)");
			}
*/
if (option('V')&V64) warn(1164,"open paren");
		}
	else if (op_close_paren)
		{
		paren_depth--;
		if (paren_depth==0)
			{
			if (if_seen)
				{
				SEQ_PT("end if exp");
				if_seen=0;
				}
			else if (for_seen)
				{
				SEQ_PT("end for");
				for_seen=0;
				}
			else if (while_seen)
				{
				SEQ_PT("end while exp");
				while_seen=0;
				}
			else if (switch_seen)
				{
				SEQ_PT("end switch exp");
				switch_seen=0;
				}
			}
if (option('V')&V64) warn(1164,"close paren");
		}
	else if (op_separator)
		{
if (option('V')&V64) 		warn(1164,"op separator");
		}
	else if (op_semicolon)
		{
		if (for_seen)
			{
			SEQ_PT("for exp");
			for_seen--;
			}
if (option('V')&V64) warn(1164,"op semicolon");
		}
	else if (op_open_funargs)
		{
if (option('V')&V64) warn(1164,"open funargs");
		depth++;
		switch(depth)
			{
			case(1):	call_count1=0;	break;
			case(2):	call_count2=0;	break;
			case(3):	call_count3=0;	break;
			case(4):	call_count4=0;	break;
			case(5):	call_count5=0;	break;
			case(6):	call_count6=0;	break;
			case(7):	call_count7=0;	break;
			default:	warn(9101,"depth too great at %d - inform PSD",depth);
			}
		}
	else if (op_close_funargs)
		{
if (option('V')&V64) warn(1164,"close funargs");
		switch(depth)
			{
			case(1):	called_value=call_count1; call_count1=0;	break;
			case(2):	called_value=call_count2; call_count2=0;	break;
			case(3):	called_value=call_count3; call_count3=0;	break;
			case(4):	called_value=call_count4; call_count4=0;	break;
			case(5):	called_value=call_count5; call_count5=0;	break;
			case(6):	called_value=call_count6; call_count6=0;	break;
			case(7):	called_value=call_count7; call_count7=0;	break;
			default:	warn(9101,"depth too great at %d - inform PSD",depth);
			}
		if (called_value>1)
			{
	if (option('W') & W2 ) warn(1002,"Warning: %d fcn calls in one arg list; check G1.9",
		called_value);
			}
		SEQ_PT("fcn call");
		depth--;
		}
	else if (op_open_angle)
		{
if (option('V')&V64) warn(1164,"open angle");
		}
	else if (op_close_angle)
		{
if (option('V')&V64) warn(1164,"close angle");
		}
	else if (op_open_brace)
		{
if (option('V')&V64) warn(1164,"open brace");
		//equals_count=0;
		assign_count=0;
		//call_count_0=0;
		}
	else if (op_close_brace)
		{
if (option('V')&V64) warn(1164,"close brace");
		}
	else
		{
if (option('V')&V64) warn(1164,"other punctuation");
		}
	}



